/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __CLEANUP_HEADER_INCLUDED__
#define __CLEANUP_HEADER_INCLUDED__

#include <g_globals.h>
#include <lists.h>

typedef void(*proc_cleanup)(int, void *);

typedef struct cleanup_list{
	struct cleanup_list *next;
	proc_cleanup	cleanup;
	void		*priv;
}cleanup_list_t, *p_cleanup_list;


int clenup_init(void);
int cleanup_add_handler(proc_cleanup handler, void *priv);
void cleanup(int code);

/* Generic cleanup handlers */
void cleanup_lock(int, void *);
void cleanup_arg(int, void *);
void cleanup_kv(int, void *);
void cleanup_c_capdev(int, void *);

#endif /* __CLEANUP_HEADER_INCLUDED__ */
