/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __LOADER_HEADER_INCLUDED__
#define __LOADER_HEADER_INCLUDED__

#include <g_globals.h>
#include <lists.h>
#include <plugins.h>

#define MAX_PLUGINS 1024
#define PLUGIN_MODE RTLD_LAZY

int loader_init(void);
void loader_cleanup(int, void *);
int loader_load_dir(char *, int);

typedef struct plugin_list{
	struct plugin_list	*next;
	void			*lib;
	char			*name;
	char			*desc;
	uint			ver_major, ver_minor;
	proc_plugin_init	init;
	proc_plugin_unload	unload;
}plugin_list_t, *p_plugin_list;

#endif /* __LOADER_HEADER_INCLUDED__ */

